'Ported from WinHTTP.au3 by trancexx to FB by UEZ
'Build 2021-03-15 Beta
'Windows 7 / Windows Server 2008 R2 / Server 2012 must enable TLS 1.1 and TLS 1.2 as default secure protocols in WinHTTP in Windows ->
'https://support.microsoft.com/en-us/topic/update-to-enable-tls-1-1-and-tls-1-2-as-default-secure-protocols-in-winhttp-in-windows-c4bd73d2-31d7-761e-0178-11268bb10392


#Include Once "windows.bi"

Type HINTERNET As LPVOID

#Ifndef CRLF
	#Define CRLF	Chr(10, 13)
#Endif

Const WINHTTP_ACCESS_TYPE_DEFAULT_PROXY = 0, WINHTTP_ACCESS_TYPE_NO_PROXY = 1, WINHTTP_ACCESS_TYPE_NAMED_PROXY = 3, WINHTTP_ACCESS_TYPE_AUTOMATIC_PROXY = 4, WINHTTP_FLAG_ESCAPE_DISABLE = &h00000040, _
	  INTERNET_DEFAULT_HTTPS_PORT = 443, INTERNET_DEFAULT_HTTP_PORT = 80, INTERNET_DEFAULT_PORT = 0, WINHTTP_NO_PROXY_NAME = "", WINHTTP_NO_PROXY_BYPASS = "", WINHTTP_NO_REFERER = "", _
	  WINHTTP_DEFAULT_ACCEPT_TYPES = 0, WINHTTP_FLAG_SECURE = &h00800000, WINHTTP_NO_ADDITIONAL_HEADERS = "", WINHTTP_NO_REQUEST_DATA = 0, WINHTTP_CALLBACK_STATUS_REDIRECT = &h00004000

Dim Shared As Any Ptr __hWinHTTPLib = 0
Dim Shared WinHttpOpen As Function(sUserAgent As LPCWSTR, iAccessType As Long, sProxyName As LPCWSTR, sProxyBypass As LPCWSTR, iFlag As Long) As HINTERNET
Dim Shared WinHttpCloseHandle As Function(__hWinHTTPLib As Any Ptr) As Boolean
Dim Shared WinHttpConnect As Function(hSession As HINTERNET, sServerName As LPCWSTR, iServerPort As Long, Reserved As DWORD) As HINTERNET
Dim Shared WinHttpOpenRequest As Function(hConnect As HINTERNET, sVerb As LPCWSTR, sObjectName As LPCWSTR, sVersion As LPCWSTR, sReferrer As LPCWSTR, pAcceptTypes As Any Ptr, iFlags As Long) As HINTERNET
Dim Shared WinHttpSendRequest As Function(hInternet As HINTERNET, sHeader As LPCWSTR, iHeadersLength As Long, pOptionalBuff As HINTERNET, iOptionalLength As Long, iTotalLength As Long, pContext As DWORD_PTR) As Boolean
Dim Shared WinHttpReceiveResponse As Function(hInternet As HINTERNET, iReserved As LPVOID) As Boolean
Dim Shared WinHttpReadData As Function(hRequest As HINTERNET, pBuffer As LPVOID, iNumberOfBytesToRead As Long, pNumberOfBytesRead As LPDWORD) As Boolean
Dim Shared WinHttpQueryDataAvailable As Function(hRequest As HINTERNET, pNumberOfBytesAvailable As LPDWORD) As Boolean
Dim Shared WinHttpSetTimeouts As Function(hInternet As HINTERNET, iResolveTimeout As Integer, iConnectTimeout As Integer, iSendTimeout As Integer, iReceiveTimeout As Integer) As Boolean
Dim Shared WinHttpCheckPlatform As Function() As Boolean
Dim Shared WinHttpSetStatusCallback As Function(hConnect As HINTERNET, lpfnInternetCallback as Any Ptr, dwNotificationFlags as DWORD, dwReserved as DWORD_PTR) As any Ptr


Function _WinHttpStartup() As Boolean
	__hWinHTTPLib = Dylibload("Winhttp.dll")
	If __hWinHTTPLib = 0 Then Return False
	WinHttpOpen = Dylibsymbol(__hWinHTTPLib, "WinHttpOpen")
	WinHttpCloseHandle = Dylibsymbol(__hWinHTTPLib, "WinHttpCloseHandle")
	WinHttpConnect = Dylibsymbol(__hWinHTTPLib, "WinHttpConnect")
	WinHttpOpenRequest = Dylibsymbol(__hWinHTTPLib, "WinHttpOpenRequest")
	WinHttpSendRequest = Dylibsymbol(__hWinHTTPLib, "WinHttpSendRequest")
	WinHttpReceiveResponse = Dylibsymbol(__hWinHTTPLib, "WinHttpReceiveResponse")
	WinHttpReadData = Dylibsymbol(__hWinHTTPLib, "WinHttpReadData")
	WinHttpQueryDataAvailable = Dylibsymbol(__hWinHTTPLib, "WinHttpQueryDataAvailable")
	WinHttpSetTimeouts = Dylibsymbol(__hWinHTTPLib, "WinHttpSetTimeouts")
	WinHttpCheckPlatform = Dylibsymbol(__hWinHTTPLib, "WinHttpCheckPlatform")
	WinHttpSetStatusCallback = Dylibsymbol(__hWinHTTPLib, "WinHttpSetStatusCallback")
	Return WinHttpCheckPlatform()
End Function

Function _WinHttpShutdown() As Boolean
	If __hWinHTTPLib Then 
		Dylibfree(__hWinHTTPLib)
		Return True
	Endif
	Return False
End Function

Function _WinHttpOpen(iAccessType As Long = WINHTTP_ACCESS_TYPE_AUTOMATIC_PROXY, sUserAgent As String = "FB_WinHTTP/1.0", sProxyName As String = WINHTTP_NO_PROXY_NAME, sProxyBypass As String = WINHTTP_NO_PROXY_BYPASS, iFlag As Long = 0) As HINTERNET
	If __hWinHTTPLib = 0 Then Return 0
	Return WinHttpOpen(Wstr(sUserAgent), iAccessType, Wstr(sProxyName), Wstr(sProxyBypass), iFlag)
End Function

Function _WinHttpCloseHandle(__hInternet As Any Ptr = __hWinHTTPLib) As Boolean
	If __hInternet = 0 Then Return False
	Return WinHttpCloseHandle(__hInternet)
End Function

Function _WinHttpConnect(hSession As HINTERNET, sServerName As String, iServerPort As Long = INTERNET_DEFAULT_PORT) As HINTERNET
	If hSession = 0 Then Return 0
	Return WinHttpConnect(hSession, Wstr(sServerName), iServerPort, 0)	
End Function

Function _WinHttpOpenRequest(hConnect As HINTERNET, sVerb As String = "GET", sObjectName As String = "", sVersion As String = "HTTP/1.1", sReferrer As String = WINHTTP_NO_REFERER, pAcceptTypes As Any Ptr = WINHTTP_DEFAULT_ACCEPT_TYPES, iFlags As Long = WINHTTP_FLAG_ESCAPE_DISABLE) As HINTERNET
	If hConnect = 0 Then Return 0
	Return WinHttpOpenRequest(hConnect, Wstr(Ucase(sVerb)), Wstr(sObjectName), Wstr(Ucase(sVersion)), Wstr(sReferrer), pAcceptTypes, iFlags)
End Function

Function _WinHttpQueryDataAvailable(hRequest As HINTERNET, Byref pNumberOfBytesAvailable As LPDWORD = NULL) As Ulong
	If hRequest = 0 Then Return 0
	Return WinHttpQueryDataAvailable(hRequest, pNumberOfBytesAvailable)
End Function

Function _WinHttpReadData(hRequest As HINTERNET, iNumberOfBytesToRead As Uinteger = 8192) As String
	If hRequest = 0 Then Return ""
	Dim As Ulong iNumberOfBytesRead = 0, i
	Dim As Ubyte aBuffer(iNumberOfBytesToRead)
	WinHttpReadData(hRequest, @aBuffer(0), iNumberOfBytesToRead, @iNumberOfBytesRead)
	If iNumberOfBytesRead = 0 Then Return ""
	Dim As String sHTML
	For i = 0 To iNumberOfBytesRead
		sHTML &= Chr(aBuffer(i))
	Next
	Return sHTML
End Function

Function _WinHttpReceiveResponse(hRequest As HINTERNET) As Boolean
	If hRequest = 0 Then Return False
	Dim as Boolean iResult = WinHttpReceiveResponse(hRequest, 0)
	If iResult = False Then ? "Error " & GetLastError() & " in function _WinHttpReceiveResponse!"
	Return iResult
End Function

Function _WinHttpSendRequest(hRequest As HINTERNET, sHeaders As String = WINHTTP_NO_ADDITIONAL_HEADERS, pOptional As LPVOID = WINHTTP_NO_REQUEST_DATA, iOptionalLength as DWORD = 0, iTotalLength As DWORD = 0, pContext As DWORD_PTR = 0) As Boolean
	If hRequest = 0 Then Return False
'	Dim As Ulong iOptionalLength = Len(sOptional), i
'	Dim As Ubyte aOptional(Len(sOptional) - 1)
'	If iOptionalLength > 0 Then
'		For i = 0 To iOptionalLength - 1
'			aOptional(i) = Asc(Mid(sOptional, i + 1, 1))
'		Next
'	End If
'	If iTotalLength = 0 Or iTotalLength < iOptionalLength Then iTotalLength += iOptionalLength
	Dim as Boolean iResult = WinHttpSendRequest(hRequest, Wstr(sHeaders), 0, pOptional, iOptionalLength, iTotalLength, pContext)
	If iResult = False Then ? "Error " & GetLastError() & " in function _WinHttpSendRequest!"
	Return iResult
End Function

Function _WinHttpSimpleReadData(hRequest As HINTERNET) As String
	If hRequest = 0 Then Return ""
	If _WinHttpQueryDataAvailable(hRequest) > 0 Then
		Dim As String sData, d
		Do
			d = _WinHttpReadData(hRequest)
			If d = "" Then Exit Do
			sData &= d
		Loop Until False
		Return sData
	End If
	Return ""
End Function

Function _WinHttpSimpleSendRequest(hConnect As HINTERNET, sPath As String = "", sType As String = "GET", sReferrer As String = WINHTTP_NO_REFERER, pData As LPVOID = WINHTTP_NO_REQUEST_DATA, sHeader As String = WINHTTP_NO_ADDITIONAL_HEADERS) As HINTERNET
	If hConnect = 0 Then Return 0
	Dim As HINTERNET hRequest = _WinHttpOpenRequest(hConnect, Ucase(sType), sPath, "HTTP/1.1", sReferrer)
	If hRequest = 0 Then Return 0
	If sType = Ucase("POST") And sHeader = WINHTTP_NO_ADDITIONAL_HEADERS Then sHeader = "Content-Type: application/x-www-form-urlencoded" & CRLF
	If _WinHttpSendRequest(hRequest, sHeader, pData) = False Then Return 0
	If _WinHttpReceiveResponse(hRequest) = False Then Return 0
	Return hRequest
End Function

Function _WinHttpSetStatusCallback(hConnect As HINTERNET, pCallback as Any Ptr, NotificationFlags as Dword) as Any Ptr
	If hConnect = 0 Then Return False
	Return WinHttpSetStatusCallback(hConnect, pCallback, NotificationFlags, 0)
End function